<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<title>json-c: printbuf.h File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">json-c
   &#160;<span id="projectnumber">0.14</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.2 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="annotated.html"><span>Data&#160;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#nested-classes">Data Structures</a> &#124;
<a href="#define-members">Macros</a> &#124;
<a href="#typedef-members">Typedefs</a> &#124;
<a href="#func-members">Functions</a>  </div>
  <div class="headertitle">
<div class="title">printbuf.h File Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>Internal string buffer handing. Unless you're writing a json_object_to_json_string_fn implementation for use with <a class="el" href="json__object_8h.html#a889345512a214b8f78f6a73561523c7c">json_object_set_serializer()</a> direct use of this is not recommended.  
<a href="#details">More...</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="nested-classes"></a>
Data Structures</h2></td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structprintbuf.html">printbuf</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="define-members"></a>
Macros</h2></td></tr>
<tr class="memitem:a2a31d5c00f3a4712f2d5d62aee66344e"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="printbuf_8h.html#a2a31d5c00f3a4712f2d5d62aee66344e">JSON_EXPORT</a>&#160;&#160;&#160;extern</td></tr>
<tr class="separator:a2a31d5c00f3a4712f2d5d62aee66344e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6f3a4dc87fab41c37e3eff42f40dc346"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="printbuf_8h.html#a6f3a4dc87fab41c37e3eff42f40dc346">printbuf_memappend_fast</a>(p, bufptr, bufsize)</td></tr>
<tr class="separator:a6f3a4dc87fab41c37e3eff42f40dc346"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acdd84ad88987c0166b7ba0e3f1f8f1bb"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="printbuf_8h.html#acdd84ad88987c0166b7ba0e3f1f8f1bb">printbuf_length</a>(p)&#160;&#160;&#160;((p)-&gt;bpos)</td></tr>
<tr class="separator:acdd84ad88987c0166b7ba0e3f1f8f1bb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab009973c5e15aae191e610cd70752603"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="printbuf_8h.html#ab009973c5e15aae191e610cd70752603">_printbuf_check_literal</a>(mystr)&#160;&#160;&#160;(&quot;&quot; mystr)</td></tr>
<tr class="separator:ab009973c5e15aae191e610cd70752603"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2f30492682f5fbc59a8749b428e0e4ba"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="printbuf_8h.html#a2f30492682f5fbc59a8749b428e0e4ba">printbuf_strappend</a>(pb, str)&#160;&#160;&#160;<a class="el" href="printbuf_8h.html#a9c193d30e9ca4936ea28a6c9e8e4f6f0">printbuf_memappend</a>((pb), <a class="el" href="printbuf_8h.html#ab009973c5e15aae191e610cd70752603">_printbuf_check_literal</a>(str), sizeof(str) - 1)</td></tr>
<tr class="separator:a2f30492682f5fbc59a8749b428e0e4ba"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="typedef-members"></a>
Typedefs</h2></td></tr>
<tr class="memitem:ace274df280df67463ff417b1b3392395"><td class="memItemLeft" align="right" valign="top">typedef struct <a class="el" href="structprintbuf.html">printbuf</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="printbuf_8h.html#ace274df280df67463ff417b1b3392395">printbuf</a></td></tr>
<tr class="separator:ace274df280df67463ff417b1b3392395"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:a645670fa132f0ae9a75f43c0b464bdaf"><td class="memItemLeft" align="right" valign="top"><a class="el" href="printbuf_8h.html#a2a31d5c00f3a4712f2d5d62aee66344e">JSON_EXPORT</a> struct <a class="el" href="structprintbuf.html">printbuf</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="printbuf_8h.html#a645670fa132f0ae9a75f43c0b464bdaf">printbuf_new</a> (void)</td></tr>
<tr class="separator:a645670fa132f0ae9a75f43c0b464bdaf"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9c193d30e9ca4936ea28a6c9e8e4f6f0"><td class="memItemLeft" align="right" valign="top"><a class="el" href="printbuf_8h.html#a2a31d5c00f3a4712f2d5d62aee66344e">JSON_EXPORT</a> int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="printbuf_8h.html#a9c193d30e9ca4936ea28a6c9e8e4f6f0">printbuf_memappend</a> (struct <a class="el" href="structprintbuf.html">printbuf</a> *p, const char *buf, int size)</td></tr>
<tr class="separator:a9c193d30e9ca4936ea28a6c9e8e4f6f0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a93a27f4f8a092c58666724de23ae804d"><td class="memItemLeft" align="right" valign="top"><a class="el" href="printbuf_8h.html#a2a31d5c00f3a4712f2d5d62aee66344e">JSON_EXPORT</a> int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="printbuf_8h.html#a93a27f4f8a092c58666724de23ae804d">printbuf_memset</a> (struct <a class="el" href="structprintbuf.html">printbuf</a> *pb, int offset, int charvalue, int len)</td></tr>
<tr class="separator:a93a27f4f8a092c58666724de23ae804d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a61f6bc0b1ca5787f0faca6799d61a0bb"><td class="memItemLeft" align="right" valign="top"><a class="el" href="printbuf_8h.html#a2a31d5c00f3a4712f2d5d62aee66344e">JSON_EXPORT</a> int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="printbuf_8h.html#a61f6bc0b1ca5787f0faca6799d61a0bb">sprintbuf</a> (struct <a class="el" href="structprintbuf.html">printbuf</a> *p, const char *msg,...)</td></tr>
<tr class="separator:a61f6bc0b1ca5787f0faca6799d61a0bb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a705c62167df13e65e04de9ae60f6e136"><td class="memItemLeft" align="right" valign="top"><a class="el" href="printbuf_8h.html#a2a31d5c00f3a4712f2d5d62aee66344e">JSON_EXPORT</a> void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="printbuf_8h.html#a705c62167df13e65e04de9ae60f6e136">printbuf_reset</a> (struct <a class="el" href="structprintbuf.html">printbuf</a> *p)</td></tr>
<tr class="separator:a705c62167df13e65e04de9ae60f6e136"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2b744266191ef5e3102fbf910e790a98"><td class="memItemLeft" align="right" valign="top"><a class="el" href="printbuf_8h.html#a2a31d5c00f3a4712f2d5d62aee66344e">JSON_EXPORT</a> void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="printbuf_8h.html#a2b744266191ef5e3102fbf910e790a98">printbuf_free</a> (struct <a class="el" href="structprintbuf.html">printbuf</a> *p)</td></tr>
<tr class="separator:a2b744266191ef5e3102fbf910e790a98"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>Internal string buffer handing. Unless you're writing a json_object_to_json_string_fn implementation for use with <a class="el" href="json__object_8h.html#a889345512a214b8f78f6a73561523c7c">json_object_set_serializer()</a> direct use of this is not recommended. </p>
</div><h2 class="groupheader">Macro Definition Documentation</h2>
<a class="anchor" id="ab009973c5e15aae191e610cd70752603"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define _printbuf_check_literal</td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">mystr</td><td>)</td>
          <td>&#160;&#160;&#160;(&quot;&quot; mystr)</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Results in a compile error if the argument is not a string literal. </p>

</div>
</div>
<a class="anchor" id="a2a31d5c00f3a4712f2d5d62aee66344e"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define JSON_EXPORT&#160;&#160;&#160;extern</td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a class="anchor" id="acdd84ad88987c0166b7ba0e3f1f8f1bb"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define printbuf_length</td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">p</td><td>)</td>
          <td>&#160;&#160;&#160;((p)-&gt;bpos)</td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a class="anchor" id="a6f3a4dc87fab41c37e3eff42f40dc346"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define printbuf_memappend_fast</td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">p, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">bufptr, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">bufsize&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<b>Value:</b><div class="fragment"><div class="line"><span class="keywordflow">do</span>                                                           \</div>
<div class="line">        {                                                            \</div>
<div class="line">                if ((p-&gt;size - p-&gt;bpos) &gt; bufsize)                   \</div>
<div class="line">                {                                                    \</div>
<div class="line">                        memcpy(p-&gt;buf + p-&gt;bpos, (bufptr), bufsize); \</div>
<div class="line">                        p-&gt;bpos += bufsize;                          \</div>
<div class="line">                        p-&gt;buf[p-&gt;bpos] = <span class="charliteral">&#39;\0&#39;</span>;                      \</div>
<div class="line">                }                                                    \</div>
<div class="line">                else                                                 \</div>
<div class="line">                {                                                    \</div>
<div class="line">                        printbuf_memappend(p, (bufptr), bufsize);    \</div>
<div class="line">                }                                                    \</div>
<div class="line">        } <span class="keywordflow">while</span> (0)</div>
</div><!-- fragment -->
</div>
</div>
<a class="anchor" id="a2f30492682f5fbc59a8749b428e0e4ba"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define printbuf_strappend</td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">pb, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">str&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td>&#160;&#160;&#160;<a class="el" href="printbuf_8h.html#a9c193d30e9ca4936ea28a6c9e8e4f6f0">printbuf_memappend</a>((pb), <a class="el" href="printbuf_8h.html#ab009973c5e15aae191e610cd70752603">_printbuf_check_literal</a>(str), sizeof(str) - 1)</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>This is an optimization wrapper around <a class="el" href="printbuf_8h.html#a9c193d30e9ca4936ea28a6c9e8e4f6f0">printbuf_memappend()</a> that is useful for appending string literals. Since the size of string constants is known at compile time, using this macro can avoid a costly strlen() call. This is especially helpful when a constant string must be appended many times. If you got here because of a compilation error caused by passing something other than a string literal, use <a class="el" href="printbuf_8h.html#a6f3a4dc87fab41c37e3eff42f40dc346">printbuf_memappend_fast()</a> in conjunction with strlen().</p>
<p>See also: <a class="el" href="printbuf_8h.html#a6f3a4dc87fab41c37e3eff42f40dc346">printbuf_memappend_fast()</a> <a class="el" href="printbuf_8h.html#a9c193d30e9ca4936ea28a6c9e8e4f6f0">printbuf_memappend()</a> <a class="el" href="printbuf_8h.html#a61f6bc0b1ca5787f0faca6799d61a0bb">sprintbuf()</a> </p>

</div>
</div>
<h2 class="groupheader">Typedef Documentation</h2>
<a class="anchor" id="ace274df280df67463ff417b1b3392395"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef struct <a class="el" href="structprintbuf.html">printbuf</a> <a class="el" href="structprintbuf.html">printbuf</a></td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<h2 class="groupheader">Function Documentation</h2>
<a class="anchor" id="a2b744266191ef5e3102fbf910e790a98"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="printbuf_8h.html#a2a31d5c00f3a4712f2d5d62aee66344e">JSON_EXPORT</a> void printbuf_free </td>
          <td>(</td>
          <td class="paramtype">struct <a class="el" href="structprintbuf.html">printbuf</a> *&#160;</td>
          <td class="paramname"><em>p</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a class="anchor" id="a9c193d30e9ca4936ea28a6c9e8e4f6f0"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="printbuf_8h.html#a2a31d5c00f3a4712f2d5d62aee66344e">JSON_EXPORT</a> int printbuf_memappend </td>
          <td>(</td>
          <td class="paramtype">struct <a class="el" href="structprintbuf.html">printbuf</a> *&#160;</td>
          <td class="paramname"><em>p</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>buf</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>size</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a class="anchor" id="a93a27f4f8a092c58666724de23ae804d"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="printbuf_8h.html#a2a31d5c00f3a4712f2d5d62aee66344e">JSON_EXPORT</a> int printbuf_memset </td>
          <td>(</td>
          <td class="paramtype">struct <a class="el" href="structprintbuf.html">printbuf</a> *&#160;</td>
          <td class="paramname"><em>pb</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>offset</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>charvalue</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>len</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Set len bytes of the buffer to charvalue, starting at offset offset. Similar to calling memset(x, charvalue, len);</p>
<p>The memory allocated for the buffer is extended as necessary.</p>
<p>If offset is -1, this starts at the end of the current data in the buffer. </p>

</div>
</div>
<a class="anchor" id="a645670fa132f0ae9a75f43c0b464bdaf"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="printbuf_8h.html#a2a31d5c00f3a4712f2d5d62aee66344e">JSON_EXPORT</a> struct <a class="el" href="structprintbuf.html">printbuf</a>* printbuf_new </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">read</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a class="anchor" id="a705c62167df13e65e04de9ae60f6e136"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="printbuf_8h.html#a2a31d5c00f3a4712f2d5d62aee66344e">JSON_EXPORT</a> void printbuf_reset </td>
          <td>(</td>
          <td class="paramtype">struct <a class="el" href="structprintbuf.html">printbuf</a> *&#160;</td>
          <td class="paramname"><em>p</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a class="anchor" id="a61f6bc0b1ca5787f0faca6799d61a0bb"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="printbuf_8h.html#a2a31d5c00f3a4712f2d5d62aee66344e">JSON_EXPORT</a> int sprintbuf </td>
          <td>(</td>
          <td class="paramtype">struct <a class="el" href="structprintbuf.html">printbuf</a> *&#160;</td>
          <td class="paramname"><em>p</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>msg</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>...</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Formatted print to printbuf.</p>
<p>This function is the most expensive of the available functions for appending string data to a printbuf and should be used only where convenience is more important than speed. Avoid using this function in high performance code or tight loops; in these scenarios, consider using snprintf() with a static buffer in conjunction with one of the printbuf_*append() functions.</p>
<p>See also: <a class="el" href="printbuf_8h.html#a6f3a4dc87fab41c37e3eff42f40dc346">printbuf_memappend_fast()</a> <a class="el" href="printbuf_8h.html#a9c193d30e9ca4936ea28a6c9e8e4f6f0">printbuf_memappend()</a> <a class="el" href="printbuf_8h.html#a2f30492682f5fbc59a8749b428e0e4ba">printbuf_strappend()</a> </p>

</div>
</div>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Sun Apr 19 2020 03:40:44 for json-c by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.2
</small></address>
</body>
</html>
